/*  -*- pse-c -*-
 *----------------------------------------------------------------------------
 * Filename: common.h
 * $Revision: 1.4 $
 *----------------------------------------------------------------------------
 * This file contains the header files that is common for all the Tests files
 * Copyright © 2009, Intel Corporation.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms and conditions of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 
 * 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

/* Copyright 2009 Intel Corporation. All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *	Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *
 *      Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 *      Neither the name Intel Corporation nor the names of its contributors
 *      may be used to endorse or promote products derived from this software
 *      without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

#include <asm/atomic.h>
#include <asm/bitops.h>
#include <asm/cacheflush.h>
#include <asm/cpufeature.h>
#include <asm/highmem.h>
#include <asm/io.h>
#include <asm/mmx.h>
#include <asm/msr.h>
#include <asm/page.h>
#include <asm/pgtable.h>
#include <asm/tlbflush.h>
#include <asm/tlb.h>
#include <asm/uaccess.h>
#include <asm-generic/iomap.h>
#include <linux/gfp.h>
#include <linux/list.h>
#include <linux/mm.h>
#include <linux/page-flags.h>
#include <linux/pci.h>
#include <linux/rwsem.h>
#include <linux/slab.h>
#include <linux/smp.h>
#include <linux/smp_lock.h>
#include <linux/spinlock.h>
#include <linux/string.h>
#include <linux/types.h>
#include <linux/version.h>
#include <linux/vmalloc.h>

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,10)
#define PCI_SAVE_STATE(a,b) pci_save_state(a,b)
#define PCI_RESTORE_STATE(a,b) pci_restore_state(a,b)
#else
#define PCI_SAVE_STATE(a,b) pci_save_state(a)
#define PCI_RESTORE_STATE(a,b) pci_restore_state(a)
#endif

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,23)
#define AGP_UNLOCK_PAGE(a)
#else
#include <linux/pagemap.h>
#define AGP_UNLOCK_PAGE(a) unlock_page((a))
#endif


#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,24)
#include <asm-i386/system.h>
#include <asm-i386/uaccess.h>
#endif

#if LINUX_VERSION_CODE == KERNEL_VERSION(2,6,25)
#include <asm-x86/system.h>
#include <asm-x86/uaccess.h>
#endif

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,25)
#define SET_PAGES_WB(a,b)	set_pages_wb(a,b)
#ifndef SetPageLocked
#define SetPageLocked(page) set_bit(PG_locked, &page->flags);
#endif
#else
#define SET_PAGES_WB(a,b)	change_page_attr(a,b,PAGE_KERNEL)
#endif

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,27)
#define ON_EACH_CPU(a,b,c,d)	on_each_cpu(a,b,d)
#else
#define ON_EACH_CPU(a,b,c,d) 	on_each_cpu(a,b,c,d)
#endif
